# Getting Started

[Fluent Bit](http://fluentbit.io) is a straightforward tool and to get started with it we need to understand a few concepts involved.

The nature of Fluent Bit is to gather data from an __input__ interface, do buffering and then flush the records through an __output__. Every input and output interfaces are implemented through a __plugin__.

When a __plugin__ is loaded, multiple instances of it can be started and in order to instruct the core how to route the records between input and output instances, a __tag__ and a __match__ are required:

- Input plugin instances are _tagged_
- Output plugin instances defines a _match_

When a record is buffered it contains a __tag__, then the router lookup the output instances that have a __match__ for it, then it deliver the data as required.

In order to understand more _how it works_ we will introduce some concepts:

- Input
- Output
- Engine
- Routing

## Input

[Fluent Bit](http://fluentbit.io) provides different input plugins to gather information from, some of them just collect operating system metrics while others interact with radio devices or listen from specific protocols data.

When an input plugin is loaded, an internal _instance_ of it is created. An instance can have it own configuration, the settings available are called __properties__. Input plugins inherit some fixed properties and also the plugin may expose their own too.

## Output

Similar to the input plugins, Fluent Bit provides __output plugins__ which are in charge to deliver the data generated by the inputs to some destination, which can be network service or the file system.

When an output plugin is enabled, an internal _instance_ of it is created. This instance is also configurable through it supported properties.

## Engine

The Engine is the core runtime who schedule to retrieve data from the input plugin or receive notifications from them to collect it. Once it buffers the data, it lookup the destination of the records using the router paths defined at start time, then the records are passed to the right output plugins to deliver the data.

## Routing

For Fluent Bit, _routing_ means the action to define paths for the data collected. So for each input plugin instance, exists a configuration property called __tag__. In the other side the output plugin instances are configured with a property called __match__, which is a rule to match incoming data under a specific __tag__ pattern.
