# CPU Usage

The __cpu__ input plugin, measure the CPU usage by the system and per CPU core in a percentage unit between every second of time. At the moment this plugin is only available for Linux.

The following tables describes the information generated by the plugin. The keys below represent the data used by the overall system, all values associated to the keys are in a percentage unit (0 to 100%):

| key        | description          |
|------------|----------------------|
| cpu_p      | CPU usage of the overall system, this value is the summatory of time spent on user and kernel space. The result takes in consideration the numbers of CPU cores in the system.|
| user_p     | CPU usage in User mode, for short it means the CPU usage by user space programs. The result of this value takes in consideration the numbers of CPU cores in the system. |
| system_p   | CPU usage in Kernel mode, for short it means the CPU usage by the Kernel. The result of this value takes in consideration the numbers of CPU cores in the system. |


In addition to the keys reported in the above table, a similar content is created __per__ CPU core. The cores are listed from _0_ to _N_ as the Kernel reports:

| key               | description          |
|-------------------|----------------------|
| cpu__N__.p_cpu    | Represents the total CPU usage by core __N__. |
| cpu__N__.p_user   | Total CPU spent in user mode or user space programs associated to this core. |
| cpu__N__.p_system | Total CPU spent in system or kernel mode associated to this core. |

## Getting Started

In order to get the statistics of the CPU usage of your system with [Fluent Bit](http://fluentbit.io), specify the following command line arguments:

```bash
$ build/bin/fluent-bit -i cpu -o stdout
Fluent-Bit v0.6.0
Copyright (C) Treasure Data

[2016/01/07 10:46:29] [ info] starting engine
[0] [1452185189, {"cpu_p"=>7.00, "user_p"=>5.00, "system_p"=>2.00, "cpu0.p_cpu"=>10.00, "cpu0.p_user"=>8.00, "cpu0.p_system"=>2.00, "cpu1.p_cpu"=>6.00, "cpu1.p_user"=>4.00, "cpu1.p_system"=>2.00}]
[1] [1452185190, {"cpu_p"=>6.50, "user_p"=>5.00, "system_p"=>1.50, "cpu0.p_cpu"=>6.00, "cpu0.p_user"=>5.00, "cpu0.p_system"=>1.00, "cpu1.p_cpu"=>7.00, "cpu1.p_user"=>5.00, "cpu1.p_system"=>2.00}]
[2] [1452185191, {"cpu_p"=>7.50, "user_p"=>5.00, "system_p"=>2.50, "cpu0.p_cpu"=>7.00, "cpu0.p_user"=>3.00, "cpu0.p_system"=>4.00, "cpu1.p_cpu"=>6.00, "cpu1.p_user"=>6.00, "cpu1.p_system"=>0.00}]
[3] [1452185192, {"cpu_p"=>4.50, "user_p"=>3.50, "system_p"=>1.00, "cpu0.p_cpu"=>6.00, "cpu0.p_user"=>5.00, "cpu0.p_system"=>1.00, "cpu1.p_cpu"=>5.00, "cpu1.p_user"=>3.00, "cpu1.p_system"=>2.00}]
```

As described above, the CPU input plugin gather the overall usage every one second and flushed the information to the output on the fifth second. On this example we used the __stdout__ plugin to demonstrate the output records. In a real use-case you may want to flush this information to some central aggregator such as [Fluentd](http://fluentd.org) or [Elasticsearch](http://elastic.co).
